package com.maroontress.coverture;

import com.maroontress.gcovparser.AbstractFunctionGraph;
import com.maroontress.gcovparser.CorruptedFileException;
import com.maroontress.gcovparser.gcno.FunctionGraphRecord;
import java.io.PrintWriter;
import java.util.Comparator;

/**
   ؿդǤ
*/
public final class FunctionGraph extends AbstractFunctionGraph<Block, Arc> {

    /** {@inheritDoc} */
    @Override protected Block createBlock(final int id, final int blockFlags) {
	return new Block(id, blockFlags);
    }

    /** {@inheritDoc} */
    @Override protected Arc createArc(final Block start, final Block end,
				      final int flags) {
	return new Arc(start, end, flags);
    }

    /**
       ꥹȤˤδؿդɲä٤ƤΥ֥åιֹ
       μ¹Բޡޤ

       եդ褷Ƥʤϲ⤷ޤ

       @param sourceList ꥹ
    */
    public void addLineCounts(final SourceList sourceList) {
	if (!isSolved()) {
	    return;
	}
	Source source = sourceList.getSource(getSourceFile());
	source.addFunctionGraph(this);
	Iterable<Block> blocks = getBlocks();
	for (Block b : blocks) {
	    b.addLineCounts(sourceList);
	}
    }

    /**
       ؿդXMLǽϤޤ

       @param out 
    */
    public void printXML(final PrintWriter out) {
	out.printf("<functionGraph id='%d' checksum='0x%x' functionName='%s'"
		   + " sourceFile='%s' lineNumber='%d'"
		   + " complexity='%d' complexityWithFake='%d'",
		   getId(), getChecksum(), XML.escape(getFunctionName()),
		   XML.escape(getSourceFile()), getLineNumber(),
		   getComplexity(), getComplexityWithFake());
	if (isSolved()) {
	    out.printf(" called='%d' returned='%d' executedBlocks='%d'",
		       getCalledCount(), getReturnedCount(),
		       getExecutedBlockCount());
	}
	out.printf(" allBlocks='%d'>\n", getBlockCount());
	Iterable<Block> blocks = getBlocks();
	for (Block b : blocks) {
	    b.printXML(out);
	}
	out.printf("</functionGraph>\n");
    }

    /**
       ؿե쥳ɤ饤󥹥󥹤ޤ

       @param rec ؿե쥳
       @throws CorruptedFileException եι¤Ƥ뤳Ȥ򸡽
    */
    public FunctionGraph(final FunctionGraphRecord rec)
	throws CorruptedFileException {
	super(rec);
    }

    /**
       ؿϤޤֹӤ륳ѥ졼Ǥ
    */
    private static Comparator<FunctionGraph> lineNumberComparator;

    static {
	lineNumberComparator = new Comparator<FunctionGraph>() {
	    public int compare(final FunctionGraph fg1,
			       final FunctionGraph fg2) {
		return fg1.getLineNumber() - fg2.getLineNumber();
	    }
	};
    }

    /**
       ؿϤޤֹӤ륳ѥ졼֤ޤ

       @return ؿϤޤֹӤ륳ѥ졼
    */
    public static Comparator<FunctionGraph> getLineNumberComparator() {
	return lineNumberComparator;
    }
}
