package com.maroontress.coverture;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;

/**
   եݥ饹Ǥ
*/
public abstract class Processor {

    /** ϥץѥƥǤ */
    private IOProperties props;

    /**
       󥹥󥹤ޤ

       @param props ϥץѥƥ
    */
    protected Processor(final IOProperties props) {
	this.props = props;
    }

    /**
       verbose⡼ɤΤȤ˥ҡץɸ२顼Ϥɽޤ
    */
    private void verifyHeapSize() {
	if (props.isVerbose()) {
	    Runtime t = Runtime.getRuntime();
	    t.gc();
	    System.err.printf("heap: %d/%d%n", t.freeMemory(), t.maxMemory());
	}
    }

    /**
       gcovեgcovեϤǥ쥯ȥ
       ޤ
    */
    protected final void makeOutputDir() {
	if (props.isGcovEnabled()) {
	    props.makeOutputDir();
	}
    }

    /**
       gcovեޤ

       @param note Ρ
    */
    protected final void createSourceList(final Note note) {
	if (props.isGcovEnabled()) {
	    note.createSourceList(props);
	}
    }

    /**
       ե뤫gcnoե̾ΥꥹȤϤgcnoե
       ޤ

       ե̾ϥեξϡɸϤե̾ΥꥹȤ
       Ϥޤ

       @param inputFile ϤꥹȤΥե̾ޤϥϥե
       @throws IOException ϥ顼
    */
    private void processFileList(final String inputFile)
	throws IOException {
	try {
	    InputStreamReader in;
	    if (inputFile.equals("-")) {
		in = new InputStreamReader(System.in);
	    } else {
		in = new FileReader(inputFile);
	    }
	    BufferedReader rd = new BufferedReader(in);
	    String name;
	    while ((name = rd.readLine()) != null) {
		processFile(name);
	    }
	} catch (FileNotFoundException e) {
	    System.err.printf("%s: not found: %s%n",
			      inputFile, e.getMessage());
	    System.exit(1);
	}
    }

    /**
       gcnoեҤȤĽޤ

       @param name ϤgcnoեΥե̾
       @throws IOException ϥ顼
    */
    protected abstract void processFile(final String name) throws IOException;

    /**
       gcnoե˸ƤӽФޤ

       @throws IOException ϥ顼
    */
    protected abstract void pre() throws IOException;

    /**
       gcnoե˸ƤӽФޤ

       @throws IOException ϥ顼
    */
    protected abstract void post() throws IOException;

    /**
       gcnoեޤ

       @param files ե̾
       @param inputFile ϤꥹȤΥե̾ϥե󡢤ޤnull
       @throws IOException ϥ顼
    */
    public final void run(final String[] files,
			  final String inputFile) throws IOException {
	verifyHeapSize();
	pre();
	for (String arg : files) {
	    processFile(arg);
	}
	if (inputFile != null) {
	    processFileList(inputFile);
	}
	post();
	verifyHeapSize();
    }
}
