package com.maroontress.gcovparser;

/**
   ؿդΥåȤʤ륢ݥ饹Ǥˤϸ
   ꡢϥ֥åФƽλ֥åޤ

   @param <T> ֥åζݥ饹
   @param <U> ζݥ饹
*/
public abstract class AbstractArc<T extends AbstractBlock<T, U>,
				  U extends AbstractArc<T, U>> {

    /**
       ѥ˥󥰥ĥ꡼륢ɽե饰Ǥ
    */
    private static final int FLAG_ON_TREE = 0x1;

    /**
       Υɽե饰ǤΥϡ㳰longjmp()ˤ
       ơߤδؿȴ䡢exit()ʤɤΤ褦ʤؿ
       θƤӽФηϩɽޤ
    */
    private static final int FLAG_FAKE = 0x2;

    /**
       ʬʤäϩǤ뤳Ȥɽե饰Ǥ
    */
    private static final int FLAG_FALL_THROUGH = 0x4;

    /** ϥ֥åǤ */
    private T start;

    /** λ֥åǤ */
    private T end;

    /**
       Υե饰ǤFLAG_ON_TREE, FLAG_FAKE, FLAG_FALL_THROUGH
       ¤ˤʤޤ
    */
    private int flags;

    /**
       Arc is for a function that abnormally returns: Υ
       ؿθƤӽФʤȤ򼨤ޤ
    */
    private boolean callNonReturn;

    /**
       Arc is for catch/setjmp: ΥιԤ褬catchޤ
       setjmp()Ǥ뤳Ȥ򼨤ޤ
    */
    private boolean nonLocalReturn;

    /**
       Arc is an unconditional branch.
    */
    private boolean unconditional;

    /** μ¹ԲǤ */
    private long count;

    /**
       ޤ󥹥󥹤ϳϥ֥åΡֽФ
       סλ֥åΡ륢פɲäޤ

       @param start ϥ֥å
       @param end λ֥å
       @param flags ե饰
    */
    protected AbstractArc(final T start, final T end, final int flags) {
	this.start = start;
	this.end = end;
	this.flags = flags;
	this.count = 0;
	if (isFake()) {
	    if (start.getId() != 0) {
		/*
		  Exceptional exit from this function, the source
		  block must be a call.
		*/
		start.setCallSite(true);
		callNonReturn = true;
	    } else {
		/*
		  Non-local return from a callee of this function. The
		  destination block is a catch or setjmp.
		*/
		end.setNonLocalReturn(true);
		nonLocalReturn = true;
	    }
	}
    }

    /**
       ѥ˥󥰥ĥ꡼뤫ɤޤ

       @return ѥ˥󥰥ĥ꡼trueǤʤ
       false
    */
    public final boolean isOnTree() {
	return (flags & FLAG_ON_TREE) != 0;
    }

    /**
       Υɤޤ

       @return ΥξtrueǤʤfalse
    */
    public final boolean isFake() {
	return (flags & FLAG_FAKE) != 0;
    }

    /**
       ʬʤäϩǤ뤫ɤޤ

       @return ʬʤäϩξtrueǤʤ
       false
    */
    public final boolean isFallThrough() {
	return (flags & FLAG_FALL_THROUGH) != 0;
    }

    /**
       exit()ʤɤΤ褦ʤؿθƤӽФǤ뤫ɤ
       ޤ

       @return ʤؿθƤӽФξtrueǤʤfalse
    */
    public final boolean isCallNonReturn() {
	return callNonReturn;
    }

    /**
       ιԤ褬catchޤsetjmp()Ǥ뤫ɤޤ

       @return ιԤ褬catchޤsetjmp()Ǥtrue
       Ǥʤfalse
    */
    public final boolean isNonLocalReturn() {
	return nonLocalReturn;
    }

    /**
       γϥ֥åޤ

       @return ϥ֥å
    */
    public final T getStart() {
	return start;
    }

    /**
       νλ֥åޤ

       @return λ֥å
    */
    public final T getEnd() {
	return end;
    }

    /**
       ¹Բɲäޤ

       @param delta ɲä¹Բ
    */
    public final void addCount(final long delta) {
	count += delta;
    }

    /**
       ¹Բꤷޤ

       @param count ¹Բ
    */
    public final void setCount(final long count) {
	this.count = count;
    }

    /**
       ¹Բޤ

       @return ¹Բ
    */
    public final long getCount() {
	return count;
    }

    /**
       ̵ʬɤꤷޤ

       @param b ̵ʬʤtrueǤʤfalse
    */
    public final void setUnconditional(final boolean b) {
	unconditional = b;
    }

    /**
       ̵ʬɤޤ

       @return ̵ʬʤtrueǤʤfalse
    */
    public final boolean isUnconditional() {
	return unconditional;
    }
}
