package com.maroontress.gcovparser;

import java.io.File;
import java.util.ArrayList;

/**
   gcnoե˴طѥޤ
*/
public final class Origin implements Comparable<Origin> {

    /** gcnoեǤ */
    private File gcnoFile;

    /** бgcdaեǤ */
    private File gcdaFile;

    /**
       basePath򥨥פʸǤ
    */
    private String pathPrefix;

    /**
       ꥸޤ

       pathγĥҤ.gcnoǤʤФʤޤ

       @param path gcnoեΥѥ
    */
    public Origin(final String path) {
	if (!path.endsWith(".gcno")) {
	    String m = String.format("%s: suffix is not '.gcno'.", path);
	    throw new IllegalArgumentException(m);
	}
	gcnoFile = new File(path);
	String basePath = path.substring(0, path.lastIndexOf('.'));
	gcdaFile = new File(basePath + ".gcda");
	pathPrefix = escapeGcov(basePath);
    }

    /**
       ѥgcovΥǥפޤ

       @param path ѥ
       @return פѥ
    */
    private String escapeGcov(final String path) {
	String[] allComp = path.replace(File.separatorChar, '#').split("#+");
	ArrayList<String> list = new ArrayList<String>();
	for (String comp : allComp) {
	    if (comp.equals(".")) {
		continue;
	    }
	    if (comp.equals("..")) {
		comp = "^";
	    }
	    list.add(comp);
	}
	int n = list.size();
	if (n == 0) {
	    return "";
	}
	StringBuilder b = new StringBuilder(list.get(0));
	for (int k = 1; k < n; ++k) {
	    b.append("#");
	    b.append(list.get(k));
	}
	return b.toString();
    }

    /**
       gcnoեޤ

       @return gcnoե
    */
    public File getNoteFile() {
	return gcnoFile;
    }

    /**
       gcdaեޤ

       @return gcdaե
    */
    public File getDataFile() {
	return gcdaFile;
    }

    /**
       ХåեΥѥޤ

       ѥϡgcnoեΥѥĥҤΤˡХ
       оݤΥեΥѥ "##" Ϣ뤷塢Υ롼
       Ѵʸˤʤޤ

       - ѥݡͥȤζڤʸ#פѴ
       - ѥݡͥȤ.פξϺ
       - ѥݡͥȤ..פξϡ^פѴ

       @param sourceFile ХåоݤΥեΥѥ
       @return ХåեΥѥ
    */
    public String getCoverageFilePath(final String sourceFile) {
	return pathPrefix + "##" + escapeGcov(sourceFile) + ".gcov";
    }

    /**
       Τ˻ѤgcnoեΥѥǡ2ĤΥꥸŪ
       Ӥޤ

       @param origin ΥꥸӤ륪ꥸ
       @return Υꥸ0Υꥸ󤬰
       Ū˾͡Υꥸ󤬰Ū
       
       @see java.io.File#compareTo(File)
    */
    public int compareTo(final Origin origin) {
	return gcnoFile.compareTo(origin.gcnoFile);
    }
}
